#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include "sample1.h"
#include "sil.h"

#include "mdcom.h"
#include "mdcom_config.h"

void main_task()
{
	int ret;
	int i;
	mdcom_id_t block_id;
	void *p_block;

	logtask_flush(0);
	syslog(LOG_NOTICE, "MDCOM fifo test program starts.");

	/* MDCOM 初期化 */
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] start mdcom_init.");
	ret = mdcom_init(0x1, -1);
	assert(ret == 0);
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] end   mdcom_init. ret = %x", ret);
	
	/* マスタ処理完了待ち */
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] start mdcom_fifoch_wait.");
	ret = mdcom_fifoch_wait(MDCOM_FIFOCH_0, -1);
	assert(ret == 0);
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] end   mdcom_fifoch_wait. ret = %x", ret);

	/* FIFO からポインタ取得 */
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] start mdcom_fifoch_dequeue.");
	ret = mdcom_fifoch_dequeue(MDCOM_FIFOCH_0, &block_id);
	assert(ret == 0);
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] end   mdcom_fifoch_dequeue. ret = %d", ret);

	/* FIFO ブロック取得 */
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] start mdcom_fifoch_get.");
	ret = mdcom_fifoch_get(MDCOM_FIFOCH_0, block_id, &p_block);
	assert(ret == 0);
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] end   mdcom_fifoch_get. ret = %d", ret);

	/* FIFO ブロックの中身を読む */
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] MSG: %s", (char *)p_block);

	/* マスタ側へ通知 */
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] start mdcom_fifoch_notify.");
	ret = mdcom_fifoch_notify(MDCOM_FIFOCH_0);
	assert(ret == 0);
	syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] end   mdcom_fifoch_notify. ret = %d", ret);

    syslog(LOG_NOTICE, "["MDCOM_DOMAIN_NAME"] test completed.");
}
