#include <stdio.h>
#include <assert.h>
#include "mdcom.h"
#include "mdcom_config.h"

#define	SMEMCH_ID1	0

int main (int argc, char **argv)
{
	int *p_smemch1;
	int ret;
	int i;
	
	ret = 0;

	printf("MDCOM shmem test program starts.\n");

	/* MDCOM 初期化 */
	printf("["MDCOM_DOMAIN_NAME"] start mdcom_init.\n");
	do {
		ret = mdcom_init(0x0, -1);
		printf("["MDCOM_DOMAIN_NAME"] end   mdcom_init. ret = %d\n", ret);
	} while (ret != MDCOM_SUCCESS);
	printf("["MDCOM_DOMAIN_NAME"] end   mdcom_init loop.\n");
	
	/* 共有メモリポインタ取得 */
	printf("["MDCOM_DOMAIN_NAME"] start mdcom_smemch_get.\n");
	ret = mdcom_smemch_get(SMEMCH_ID1, (void **)(&p_smemch1));
	printf("["MDCOM_DOMAIN_NAME"] end   mdcom_smemch_get. ret = %x\n", ret);

#if 0	
	/* 共有メモリへ書込み */
	printf("["MDCOM_DOMAIN_NAME"] start shared memory write.\n");
	for (i = 0; i < 16; i++) {
		p_smemch1[i] = i;
	}
	printf("["MDCOM_DOMAIN_NAME"] end   shared memory write.\n");
#endif

#if 1
	/* ロック取得 */
	printf("["MDCOM_DOMAIN_NAME"] start trylock.\n");
	do {
		ret = mdcom_smemch_trylock(SMEMCH_ID1);
	} while (ret == MDCOM_LOCKED);
	printf("["MDCOM_DOMAIN_NAME"] end   trylock.\n");

	/* 共有メモリ読込み */
	printf("["MDCOM_DOMAIN_NAME"] start shared memory read.\n");
	for (i = 0; i < 16; i++) {
		printf("p_smemch1[%2d] = %8x\n", i, p_smemch1[i]);
	}
	printf("["MDCOM_DOMAIN_NAME"] end   shared memory read.\n");

	/* ロック開放 */
	printf("["MDCOM_DOMAIN_NAME"] start unlock.\n");
	ret = mdcom_smemch_unlock(SMEMCH_ID1);
	printf("["MDCOM_DOMAIN_NAME"] end   unlock. ret = %d\n", ret);
	printf("["MDCOM_DOMAIN_NAME"] test completed.\n");
#endif

	return 0;
}
